# Offtopus, offline-octopus

## Goal
Provide a way to connect local machines to work and tinker with efficiently, building prototypes with resilience in mind.

## How does it work
It provides a Web server with endpoints for different functions, including listing machines joining that network, make functions available to that new network of machines, sharing files, etc. Note that the point is to build on top of it, consequently functions as endpoints here are solely examples.

## How to install
1. clone repository
1. install dependancies (no package.json yet) but mostly express missing, i.e `npm i express`
1. run e.g `node .`
1. connect to it locally first, e.g https://localhost:8082 (assumes existing SSL certificates) or https://localhost:8082/routes

Note that the cloudinit file is an example on a brand new machine.

### tested on
- Linux machines, e.g Ubuntu on desktop, RPi Zero
- Android devices using Termux, e.g Quest 1
- iOS via iSH
Most likely partially works on Windows with Linux subsystem. System commands, e.g shutdown, xrandr, etc must be adapted.

### Developing and debugging
- See the console REPL, starting with help()
- see `/routes/json` to connect to all services

## Digging deeper
- hour long video discussion https://video.benetou.fr/w/aR81WVHg6H3E93GPG4jYUg
- self hosting AI notes https://fabien.benetou.fr/Content/SelfHostingArtificialIntelligence
- self hosting subreddit https://old.reddit.com/r/selfhosted/
- small Web https://ar.al/2020/08/07/what-is-the-small-web/
- DWeb https://en.wikipedia.org/wiki/Decentralized_web

### Inspiration
- Designing for serendipity: supporting end-user configuration of ubiquitous computing environments, Xerox PARC 2002
- Providing an Integrated User Experience of Networked Media, Devices, and Services through End-User Composition, 2008
